### *****************
###  Connect Header
### *****************

{% macro connect_hdr(c_impl_name, impl_name, domain) %}
{% if domain == "ql_tipc" %}
/**
 * {{c_impl_name}}_connect() - connect to the interface port
 * and initialize the global pointer {{c_impl_name}}.
 *
 * Requires invocation of {{c_impl_name}}_shutdown()
 * for proper teardown.
 * @Param port: port to which to connect to
 * @return: 0 on success, or an error code < 0 on failure.
 */
int {{c_impl_name}}_connect(const char* port);

/**
 * {{c_impl_name}}_shutdown() - shutdown the interface client
 *
 * Destroys the global pointer of the interface client {{c_impl_name}}.
 *
 */
void {{c_impl_name}}_shutdown(void);
{% endif %}
{% endmacro %}

### *************************
###  Connect Implementation
### *************************

{% macro connect_impl(consts, c_impl_name, impl_name, domain) %}
{% if domain == "trusty_user" %}
/**
 * {{c_impl_name}}_connect()
 * @param {{c_impl_name}} reference to the binder proxy instance
 *
 * Return: 0 on success, or an error code < 0 on failure.
 */
int {{c_impl_name}}_connect(std::optional<aidl::Bp{{impl_name}}>& {{c_impl_name}}) {
    int rc;
    rc = aidl::Bp{{impl_name}}::connect(
        {{c_impl_name}},
        aidl::I{{impl_name}}::PORT,
        IPC_CONNECT_WAIT_FOR_PORT
    );
    if (rc < 0) {
        TLOGE("Failed to connect to %s: %d\n", aidl::I{{impl_name}}::PORT, rc);
        return rc;
    }
    assert({{c_impl_name}}.has_value());
    return rc;
}
{% elif domain == "ql_tipc" %}

aidl::Bp{{impl_name}}* {{c_impl_name}} = (aidl::Bp{{impl_name}}*)NULL;

{% for s in consts.ordered_strings %}
constexpr char aidl::I{{impl_name}}::{{s["name"]}}[];
{% endfor %}

/**
 * {{c_impl_name}}_connect() - connect to the interface port
 * and initialize the global pointer {{c_impl_name}}.
 *
 * Requires invocation of {{c_impl_name}}_shutdown()
 * for proper teardown.
 * @param: port to which to connect to,
 *         if port is NULL, use the default API's port
 * Return: 0 on success, or an error code < 0 on failure.
 */
extern "C" int {{c_impl_name}}_connect(const char* port) {
    int rc;
    if ({{c_impl_name}}) {
      return NO_ERROR;
    }
    if (port) {
        rc = aidl::Bp{{impl_name}}::connect({{c_impl_name}}, port, 0);
    } else {
        rc = aidl::Bp{{impl_name}}::connect(
            {{c_impl_name}}, aidl::I{{impl_name}}::PORT, 0
        );
    }
    if (rc < 0) {
        TLOGE("Failed to connect to %s: %d\n", aidl::I{{impl_name}}::PORT, rc);
        return rc;
    }
    assert({{c_impl_name}});
    return rc;
}
{% endif %}
{% endmacro %}

### ******************************************
###  Connect teardown: only needed on ql_tipc
### ******************************************

{% macro connect_teardown(c_impl_name, impl_name, domain) %}
{% if domain == "ql_tipc" %}
/**
 * {{c_impl_name}}_shutdown() - shutdown the interface client
 *
 * Destroy the global pointer of the interface client {{c_impl_name}}.
 *
 */
extern "C" void {{c_impl_name}}_shutdown(void) {
    if ({{c_impl_name}}) {
      delete {{c_impl_name}};
      {{c_impl_name}} = (aidl::Bp{{impl_name}}*)NULL;
    }
}
{% endif %}
{% endmacro %}

### *****************
###  Connect invoke
### *****************

{% macro connect_invoke(c_impl_name, impl_name, domain) %}
{% if domain == "trusty_user" %}
    int rc;
    std::optional<aidl::Bp{{impl_name}}> {{c_impl_name}};
    rc = {{c_impl_name}}_connect({{c_impl_name}});
    if (rc < 0) {
        return rc;
    }
{% endif %}
{% if domain == "ql_tipc" %}
    int rc;
    if (!{{c_impl_name}}) {
        return ERR_BAD_STATE;
    }
{% endif %}
{%- endmacro %}
